/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Alessio Sanfratello <asanfratello@domotz.com> on 09/02/17.
 */

const LOG_EVENT = 'HANDLER - (snmpCustomDiscovery)';

var counter = 16;
var numberOfFastDiscoveryCycle = 60;

var snmpCustomDiscovery = function (resourceLocator, force) {
    console.info(LOG_EVENT + ': counter => ' + counter);

    if (force || counter === numberOfFastDiscoveryCycle) {
        var snmpCustomDiscovery = resourceLocator.discovery.snmp_custom_discovery;

        if (counter === numberOfFastDiscoveryCycle) {
            counter = 0;
        }

        snmpCustomDiscovery.discover(
            snmpCustomDiscovery.sendDiscoveryDataToEngine, undefined).then(function(lockStatus){
                "use strict";
                console.info(LOG_EVENT + 'Lock status found: ' + lockStatus);
            });
    }

    if (!force)
        counter++;
};

var discoveryForcing = function (resourceLocator) {
    resourceLocator.discovery.snmp_custom_discovery.invalidate();
    snmpCustomDiscovery(resourceLocator, true);
};


module.exports.handler = snmpCustomDiscovery;
module.exports.discoveryForcing = discoveryForcing;
