/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Manuel Macchia <manuel@domotz.com> on 07/06/16.
 */

module.exports.put = function (resourceLocator, onException, onSuccess) {
    return function (req, res) {
        var domotzUser = resourceLocator.entities.user;

        console.info('API - (%s): %s', req.method, req.url);

        var userId = req.body.user_id;
        var version = req.body.version;

        domotzUser.setAcceptedConditions(userId, version).then(function (data) {
            onSuccess(res, data);
        }).catch(function (err) {
            console.error(err.stack);
            console.error(err.status + ' - ' + err.message.error);
            onException(res, err);
        });
    };

};

module.exports.get = function (resourceLocator, onException, onSuccess) {

    return function (req, res) {
        var domotzUser = resourceLocator.entities.user;

        console.info('API - (%s): %s', req.method, req.url);

        var userId = req.query.user_id;

        domotzUser.getAcceptedConditions(userId).then(function (data) {
            onSuccess(res, data);
        }).catch(function (err) {
            console.error(err.stack);
            console.error(err.status + ' - ' + err.message.error);
            onException(res, err);
        });
    };
};