/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Andrea Azzarà <a.azzara@domotz.com> on 19/07/16.
 */


module.exports.get = function (resourceLocator, onException, onSuccess) {
    var webUtils = resourceLocator.utils.web;

    return function (req, res) {

        console.info('API - (%s): %s', req.method, req.url);

        var ignoreNoLicence = req.query.ignore_no_licence;

        var userId = webUtils.getUserId(req);
        resourceLocator.entities.user.getAvailableLicences(userId)
            .then(function (data) {
                var availableLicences = 0;
                data.forEach(function (licence) {
                    if (!licence.agent) {
                        availableLicences++;
                    }
                });

                if (ignoreNoLicence != 1 && availableLicences == 0) {
                    onException(res, {message: {error: '<p><b>The webpage must be refreshed before proceeding.</b></p><div class="dmt-buttons-block"><div class="dmt-popup-buttons"><a class="dmt-action-button" href="/"><b>REFRESH PAGE</b></a></div></div><p>Please click the above "Refresh" button and login with your credentials.</p>'}});
                }
                else {
                    onSuccess(res, data);
                }
            }).catch(function (err) {
                onException(res, err);
            });
    };
};