/** This file is part of Domotz Agent.
 * Copyright (C) 2017  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

module.exports.delete = function (resourceLocator, onException, onSuccess) {

    return function (req, res) {
        resourceLocator.userRequest.cleanData();
        onSuccess(res, {});
    };

};

module.exports.post = function (resourceLocator, onException, onSuccess) {

    return function (req, res) {
        var xSessionToken = req.headers['x-session-token'];
        if (xSessionToken) {
            resourceLocator.userRequest.setSessionToken(xSessionToken);
            onSuccess(res, {});
        }
        else {
            onException(res, {error: 'Missing Session Token'});
        }
    };

};