/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Andrea Azzarà <a.azzara@domotz.com> on 08/09/15.
 */


module.exports.get = function (resourceLocator, onException, onSuccess) {
    var domotzUser = resourceLocator.entities.user;

    return function (req, res) {
        console.info('API - (%s): %s', req.method, req.url);

        domotzUser.getRegions().then(function (data) {
            onSuccess(res, data);
        }).catch(function (err) {
            console.error(err.stack);
            console.error(err.status + ' - ' + err.message.error);
            onException(res, err);
        });
    };
};